# SelectFormat Class Reference

`#include <selfmt.h>`

Inheritance diagram for SelectFormat:

## Public Member Functions
| SelectFormat (const UnicodeString &pattern, UErrorCode &status)
| Creates a new `SelectFormat` for a given pattern string.
| SelectFormat (const SelectFormat &other)
| copy constructor.
virtual | ~SelectFormat ()
| Destructor.
void | applyPattern (const UnicodeString &pattern, UErrorCode &status)
| Sets the pattern used by this select format.
UnicodeString & | format (const UnicodeString &keyword, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const
| Selects the phrase for the given keyword.
SelectFormat & | operator= (const SelectFormat &other)
| Assignment operator.
virtual UBool | operator== (const Format &other) const
| Return true if another object is semantically equal to this one.
virtual UBool | operator!= (const Format &other) const
| Return true if another object is semantically unequal to this one.
virtual Format * | clone (void) const
| Clones this Format object polymorphically.
UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const
| Format an object to produce a string.
UnicodeString & | toPattern (UnicodeString &appendTo)
| Returns the pattern from applyPattern() or constructor.
virtual void | parseObject (const UnicodeString &source, Formattable &result, ParsePosition &parse_pos) const
| This method is not yet supported by `SelectFormat`.
virtual UClassID | getDynamicClassID () const
| ICU "poor man's RTTI", returns a UClassID for the actual class.
## Static Public Member Functions
static UClassID | getStaticClassID (void)
| ICU "poor man's RTTI", returns a UClassID for this class.

## Detailed Description

`SelectFormat` supports the creation of internationalized messages by selecting phrases based on keywords. The pattern specifies how to map keywords to phrases and provides a default phrase. The object provided to the format method is a string that's matched against the keywords. If there is a match, the corresponding phrase is selected; otherwise, the default phrase is used.

#### Using `SelectFormat` for Gender Agreement

The main use case for the select format is gender based inflection. When names or nouns are inserted into sentences, their gender can affect pronouns, verb forms, articles, and adjectives. Special care needs to be taken for the case where the gender cannot be determined. The impact varies between languages:

- English has three genders, and unknown gender is handled as a special case. Names use the gender of the named person (if known), nouns referring to people use natural gender, and inanimate objects are usually neutral. The gender only affects pronouns: "he", "she", "it", "they".
- German differs from English in that the gender of nouns is rather arbitrary, even for nouns referring to people ("Mädchen", girl, is neutral). The gender affects pronouns ("er", "sie", "es"), articles ("der", "die", "das"), and adjective forms ("guter Mann", "gute Frau", "gutes Mädchen").
- French has only two genders; as in German the gender of nouns is rather arbitrary - for sun and moon, the genders are the opposite of those in German. The gender affects pronouns ("il", "elle"), articles ("le", "la"), adjective forms ("bon", "bonne"), and sometimes verb forms ("allé", "allée").
- Polish distinguishes five genders (or noun classes), human masculine, animate non-human masculine, inanimate masculine, feminine, and neuter.

Some other languages have noun classes that are not related to gender, but similar in grammatical use. Some African languages have around 20 noun classes.

To enable localizers to create sentence patterns that take their language's gender dependencies into consideration, software has to provide information about the gender associated with a noun or name to `MessageFormat`. Two main cases can be distinguished:

- For people, natural gender information should be maintained for each person. The keywords "male", "female", "mixed" (for groups of people) and "unknown" are used.

- For nouns, grammatical gender information should be maintained for each noun and per language, e.g., in resource bundles. The keywords "masculine", "feminine", and "neuter" are commonly used, but some languages may require other keywords.

The resulting keyword is provided to `MessageFormat` as a parameter separate from the name or noun it's associated with. For example, to generate a message such as "Jean went to Paris", three separate arguments would be provided: The name of the person as argument 0, the gender of the person as argument 1, and the name of the city as argument 2. The sentence pattern for English, where the gender of the person has no impact on this simple sentence, would not refer to argument 1 at all:

    {0} went to {2}.

The sentence pattern for French, where the gender of the person affects the form of the participle, uses a select format based on argument 1:

    {0} est {1, select, female {allée} other {allé}} à {2}.

Patterns can be nested, so that it's possible to handle interactions of number and gender where necessary. For example, if the above sentence should allow for the names of several people to be inserted, the following sentence pattern can be used (with argument 0 the list of people's names, argument 1 the number of people, argument 2 their combined gender, and argument 3 the city name):

    {0} {1, plural,
                     one {est {2, select, female {allée} other  {allé}}}
                     other {sont {2, select, female {allées} other {allés}}}
              }à {3}.

#### Patterns and Their Interpretation

The `SelectFormat` pattern text defines the phrase output for each user-defined keyword. The pattern is a sequence of `keyword{phrase}` clauses. Each clause assigns the phrase `phrase` to the user-defined `keyword`.

Keywords must match the pattern [a-zA-Z][a-zA-Z0-9_-]*; keywords that don't match this pattern result in the error code `U_ILLEGAL_CHARACTER`. You always have to define a phrase for the default keyword `other`; this phrase is returned when the keyword provided to the `format` method matches no other keyword. If a pattern does not provide a phrase for `other`, the method it's provided to returns the error `U_DEFAULT_KEYWORD_MISSING`. If a pattern provides more than one phrase for the same keyword, the error `U_DUPLICATE_KEYWORD` is returned.
Spaces between `keyword` and `{phrase}` will be ignored; spaces within `{phrase}` will be preserved.

The phrase for a particular select case may contain other message format patterns. `SelectFormat` preserves these so that you can use the strings produced by `SelectFormat` with other formatters. If you are using `SelectFormat` inside a `MessageFormat` pattern, `MessageFormat` will automatically evaluate the resulting format pattern. Thus, curly braces (`{`, `}`) are only allowed in phrases to define a nested format pattern.

Example: UErrorCode status = U_ZERO_ERROR; MessageFormat *msgFmt = new MessageFormat(UnicodeString("{0} est {1, select, female {allée} other {allé}} à Paris."), Locale("fr"), status); if (U_FAILURE(status)) { return; } FieldPosition ignore(FieldPosition::DONT_CARE); UnicodeString result; char* str1= "Kirti,female"; Formattable args1[] = {"Kirti","female"}; msgFmt->format(args1, 2, result, ignore, status); cout << "Input is " << str1 << " and result is: " << result << endl; delete msgFmt;

Produces the output:
`Kirti est allée à Paris.`

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Definition at line 184 of file selfmt.h.

## Constructor & Destructor Documentation

SelectFormat::SelectFormat | ( | const UnicodeString & | pattern,
|  | UErrorCode & | status |
| ) |  |  |

Creates a new `SelectFormat` for a given pattern string.

Parameters:

  | pattern | the pattern for this `SelectFormat`. errors are returned to status if the pattern is invalid.
  | status | output param set to success/failure code on exit, which must not indicate a failure before the function call.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

SelectFormat::SelectFormat | ( | const SelectFormat & | other | ) |

copy constructor.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

virtual SelectFormat::~SelectFormat | ( |  | ) | `[virtual]`

Destructor.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

## Member Function Documentation

void SelectFormat::applyPattern | ( | const UnicodeString & | pattern,
|  | UErrorCode & | status |
| ) |  |  |

Sets the pattern used by this select format.

for the keyword rules. Patterns and their interpretation are specified in the class description.

Parameters:

  | pattern | the pattern for this select format errors are returned to status if the pattern is invalid.
  | status | output param set to success/failure code on exit, which must not indicate a failure before the function call.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

virtual Format* SelectFormat::clone | ( | void |  | ) | const`[virtual]`

Clones this Format object polymorphically.

The caller owns the result and should delete it when done.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Format.

UnicodeString& SelectFormat::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos,
|  | UErrorCode & | status |
| ) |  |  | const`[virtual]`

Format an object to produce a string.

This method handles keyword strings. If the Formattable object is not a `UnicodeString`, then it returns a failing UErrorCode.

Parameters:

  | obj | A keyword string that is used to select an alternative.
  | appendTo | output parameter to receive result. Result is appended to existing contents.
  | pos | On input: an alignment field, if desired. On output: the offsets of the alignment field.
  | status | output param filled with success/failure status.

Returns:
  Reference to 'appendTo' parameter.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Format.

UnicodeString& SelectFormat::format | ( | const UnicodeString & | keyword,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos,
|  | UErrorCode & | status |
| ) |  |  | const

Selects the phrase for the given keyword.

Parameters:

  | keyword | The keyword that is used to select an alternative.
  | appendTo | output parameter to receive result. result is appended to existing contents.
  | pos | On input: an alignment field, if desired. On output: the offsets of the alignment field.
  | status | output param set to success/failure code on exit, which must not indicate a failure before the function call.

Returns:
  Reference to 'appendTo' parameter.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

virtual UClassID SelectFormat::getDynamicClassID | ( |  | ) | const`[virtual]`

ICU "poor man's RTTI", returns a UClassID for the actual class.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Format.

static UClassID SelectFormat::getStaticClassID | ( | void |  | ) | `[static]`

ICU "poor man's RTTI", returns a UClassID for this class.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

virtual UBool SelectFormat::operator!= | ( | const Format & | other | ) | const`[virtual]`

Return true if another object is semantically unequal to this one.

Parameters:

  | other | the SelectFormat object to be compared with.

Returns:
  true if other is semantically unequal to this.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

SelectFormat& SelectFormat::operator= | ( | const SelectFormat & | other | ) |

Assignment operator.

Parameters:

  | other | the SelectFormat object to copy from.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Reimplemented from Format.

virtual UBool SelectFormat::operator== | ( | const Format & | other | ) | const`[virtual]`

Return true if another object is semantically equal to this one.

Parameters:

  | other | the SelectFormat object to be compared with.

Returns:
  true if other is semantically equal to this.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

virtual void SelectFormat::parseObject | ( | const UnicodeString & | source,
|  | Formattable & | result,
|  | ParsePosition & | parse_pos |
| ) |  |  | const`[virtual]`

This method is not yet supported by `SelectFormat`.

Before calling, set parse_pos.index to the offset you want to start parsing at in the source. After calling, parse_pos.index is the end of the text you parsed. If error occurs, index is unchanged.

When parsing, leading whitespace is discarded (with a successful parse), while trailing whitespace is left as is.

See Format::parseObject() for more.

Parameters:

  | source | The string to be parsed into an object.
  | result | Formattable to be set to the parse result. If parse fails, return contents are undefined.
  | parse_pos | The position to start parsing at. Upon return this param is set to the position after the last character successfully parsed. If the source is not parsed successfully, this param will remain unchanged.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Format.

UnicodeString& SelectFormat::toPattern | ( | UnicodeString & | appendTo | ) |

Returns the pattern from applyPattern() or constructor.

Parameters:

  | appendTo | output parameter to receive result. Result is appended to existing contents.

Returns:
  the UnicodeString with inserted pattern.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

The documentation for this class was generated from the following file:

- selfmt.h

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Defines